package eu.univento.lobby.commands;

import java.util.List;

import org.bukkit.Material;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.inventory.ItemStack;

import eu.univento.core.api.AutoCommand;
import eu.univento.core.api.languages.Messages;
import eu.univento.core.api.player.CustomPlayer;
import eu.univento.core.api.player.Rank;
import eu.univento.lobby.Lobby;

/**
 * drops items for easter eggs
 * @author joethei
 * @version 1.0
 */
public class DropItem extends AutoCommand<Lobby>{

	
	/**
	 * @param plugin main class
	 * @param command command to execute
	 * @param description describes the command
	 * @param aliases aliases of command
	 */
	public DropItem(Lobby plugin, String command, String description, String... aliases) {
		super(plugin, command, description, aliases);
	}

	@Override
	public boolean execute(CommandSender sender, String label, String[] args) {
		if(sender instanceof Player) {
			CustomPlayer p = CustomPlayer.getPlayer(sender.getName());
			Messages msgs = new Messages(p);
			if(p.isAllowed(Rank.Admin)) {
				if(args.length == 1) {
					if(args[0].equalsIgnoreCase("music_3")) {
						ItemStack music_3 = new ItemStack(Material.RECORD_3);
						p.getWorld().dropItem(p.getLocation(), music_3);
                        p.sendMessage(msgs.PREFIX() + msgs.Lobby_DROP_ITEM());
					}
					if(args[0].equalsIgnoreCase("feather")) {
						ItemStack feather = new ItemStack(Material.FEATHER);
						p.getWorld().dropItem(p.getLocation(), feather);
                        p.sendMessage(msgs.PREFIX() + msgs.Lobby_DROP_ITEM());
					}
					if(args[0].equalsIgnoreCase("hearts")) {
						ItemStack hearts = new ItemStack(Material.RED_ROSE);
						p.getWorld().dropItem(p.getLocation(), hearts);
                        p.sendMessage(msgs.PREFIX() + msgs.Lobby_DROP_ITEM());
					}
					if(args[0].equalsIgnoreCase("sugar")) {
						ItemStack sugar = new ItemStack(Material.SUGAR);
						p.getWorld().dropItem(p.getLocation(), sugar);
						p.sendMessage(msgs.PREFIX() + msgs.Lobby_DROP_ITEM());
					}
				}else{
					p.sendMessage(msgs.PREFIX() + msgs.Lobby_DROP_ITEM_USAGE());
				}
			}else{
				sender.sendMessage(msgs.NO_PERMS());
			}
		}else{
			sender.sendMessage(Messages.Console.NOT_A_PLAYER);
		}
		return true;
	}

	@Override
	public List<String> tabComplete(CommandSender sender, String label, String[] args) {
		return null;
	}

}